Attribute VB_Name = "Process"
'VAR declaration
Dim FF As Byte
Dim CurVal As Byte

Sub ControlInput(Text As TextBox, MaxVal As Integer)
 If Val(Text.Text) > MaxVal Then Text.Text = MaxVal
 If Val(Text.Text) < 0 Then Text.Text = 0
End Sub

Public Sub OpenState(Filename)
With frmEditor
If Filename = "" Then Exit Sub
Screen.MousePointer = vbHourglass
FF = FreeFile
Open Filename For Binary As #FF
'******************
' Energy Tanks
Get #FF, 2167 + 1, CurVal
.txtETanks = CurVal
' Rockets
Get #FF, 2169 + 1, CurVal
.txtRockets(0) = CurVal
Get #FF, 2170 + 1, CurVal
.txtRockets(1) = CurVal
'------------------
Close #FF
Screen.MousePointer = vbDefault
End With
End Sub
Public Sub SaveState(Filename)
With frmEditor
If Filename = "" Then Exit Sub
Screen.MousePointer = vbHourglass
FF = FreeFile
Open Filename For Binary As #FF
'******************
' Energy Tanks
Put #FF, 2167 + 1, CByte(Val(.txtETanks))
' Rockets
Put #FF, 2169 + 1, CByte(Val(.txtRockets(0)))
Put #FF, 2170 + 1, CByte(Val(.txtRockets(1)))
' Energy
If .chkEnergy.value = 1 Then
 Put #FF, 8454 + 1, CByte(153)
 Put #FF, 8455 + 1, CByte(89)
End If
' Equip
If .chkEquip.value = 1 Then Put #FF, 2168 + 1, CByte(255)
'------------------
Close #FF
Screen.MousePointer = vbDefault
End With
End Sub

Public Sub SaveInteger(Offset, value, location)
    Dim Sval As Byte
    Dim A, B, C
    A = Hex(value)
    If Len(A) = 1 Then A = "000" & A
    If Len(A) = 2 Then A = "00" & A
    If Len(A) = 3 Then A = "0" & A
    
    B = ConvertHex(Left(A, 2))
    C = ConvertHex(Right(A, 2))
    Open location For Binary As 1
        Put #1, Offset, CByte(C)
        Put #1, Offset - -1, CByte(B)
    Close 1
End Sub
Function ConvertHex(h$) As Currency
    Dim Tmp$
    Dim lo1 As Integer, lo2 As Integer
    Dim hi1 As Long, hi2 As Long
    Const Hx = "&H"
    Const BigShift = 65536
    Const LilShift = 256, Two = 2
    Tmp = h
    'In case "&H" is present
    If UCase(Left$(h, 2)) = "&H" Then Tmp = Mid$(h, 3)
    'In case there are too few characters
    Tmp = Right$("0000000" & Tmp, 8)
    'In case it wasn't a valid number
    If IsNumeric(Hx & Tmp) Then
        lo1 = CInt(Hx & Right$(Tmp, Two))
        hi1 = CLng(Hx & Mid$(Tmp, 5, Two))
        lo2 = CInt(Hx & Mid$(Tmp, 3, Two))
        hi2 = CLng(Hx & Left$(Tmp, Two))
        ConvertHex = CCur(hi2 * LilShift + lo2) * BigShift + (hi1 * LilShift) + lo1
    End If
End Function
Public Function GetInteger(value)
    Dim A$
    A$ = Hex(value)
    If Len(A$) = 1 Then A$ = "000" & A$
    If Len(A$) = 2 Then A$ = "00" & A$
    If Len(A$) = 3 Then A$ = "0" & A$
    GetInteger = ConvertHex(A$)
End Function
